/*
 * Licensed under the MIT License.
 *
 * Copyright (c) 2007 Charles D Palen
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */
/*
 * GPS_GetUI.java
 *
 * Created on October 16, 2006, 6:28 PM
 */

package my.GPS_Get;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.Timer;
import javax.swing.JOptionPane;
import java.io.*;
/**
 *
 * @author  Charles
 */
public class GPS_GetUI extends javax.swing.JFrame {
    /** Creates new form GPS_GetUI */
    
    // Setting a global datamember
    boolean GPS_SerialConnected = false;
    boolean Robot_SerialConnected = false;
    boolean Autonomus_Currently_Running = false;
    boolean GPS_Running = false;
    boolean XYZ_Running = false;
    String TempString;
    
    // Creating a two new instances of the Serial_Port class to avoid static and non-static problems with the
    // serial port methods and functions
       Serial_Port GPS_SERIAL = new Serial_Port();
       Serial_Port ROBOT_SERIAL = new Serial_Port(); 
       
    // Creating a new instance of the GPS class in order to handle GPS related calculations
       GPS_Assist MYGPS = new GPS_Assist();
                
    // Creating an new instance of the Hemmi_Control class to avoid static and non-static problems with the
    // serial port methods and functions
       Hemmi_Control Hemmison_Drive = new Hemmi_Control();
       
    public GPS_GetUI() {
        initComponents();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jTextField5 = new javax.swing.JTextField();
        jTextField6 = new javax.swing.JTextField();
        jLabel8 = new javax.swing.JLabel();
        jLabel9 = new javax.swing.JLabel();
        jLabel13 = new javax.swing.JLabel();
        jButton4 = new javax.swing.JButton();
        jButton4.setEnabled(false);
        jButton6 = new javax.swing.JButton();
        jButton6.setEnabled(false);
        jButton7 = new javax.swing.JButton();
        jButton7.setEnabled(false);
        jButton5 = new javax.swing.JButton();
        jButton5.setEnabled(false);
        jButton8 = new javax.swing.JButton();
        jButton8.setEnabled(false);
        jComboBox1 = new javax.swing.JComboBox();
        jLabel6 = new javax.swing.JLabel();
        jComboBox2 = new javax.swing.JComboBox();
        jLabel14 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jButton1 = new javax.swing.JButton();
        jLabel15 = new javax.swing.JLabel();
        jPanel3 = new javax.swing.JPanel();
        jLabel7 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        jTextField2 = new javax.swing.JTextField();
        jTextField3 = new javax.swing.JTextField();
        jLabel5 = new javax.swing.JLabel();
        jTextField4 = new javax.swing.JTextField();
        jLabel10 = new javax.swing.JLabel();
        jTextField7 = new javax.swing.JTextField();
        jLabel11 = new javax.swing.JLabel();
        jTextField8 = new javax.swing.JTextField();
        jLabel12 = new javax.swing.JLabel();
        jTextField9 = new javax.swing.JTextField();
        jButton2 = new javax.swing.JButton();
        jButton2.setEnabled(false);

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("CMU CS Get GPS");
        jPanel1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jPanel1.setName("GPS Control");
        jLabel1.setText("GPS Com Port:");

        jTextField5.setText("4335.3665");

        jTextField6.setText("8446.5449");

        jLabel8.setText("Destination Latitude");

        jLabel9.setText("Destination Longitude");

        jLabel13.setText("Manual Hemisson Control");

        jButton4.setText("F");
        jButton4.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButton4MouseClicked(evt);
            }
        });

        jButton6.setText("L");
        jButton6.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButton6MouseClicked(evt);
            }
        });

        jButton7.setText("R");
        jButton7.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButton7MouseClicked(evt);
            }
        });

        jButton5.setText("B");
        jButton5.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButton5MouseClicked(evt);
            }
        });

        jButton8.setText("STOP");
        jButton8.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButton8MouseClicked(evt);
            }
        });

        String PortList = Serial_Port.ListCommPorts();
        String[] Ports = PortList.split("\\,");
        for (int i=0; i < Ports.length; i++) {
            jComboBox1.addItem(Ports[i]);
        }

        jLabel6.setText("Robot Com Port:");

        PortList = Serial_Port.ListCommPorts();
        Ports = PortList.split("\\,");
        for (int i=0; i < Ports.length; i++) {
            jComboBox2.addItem(Ports[i]);
        }

        jLabel14.setFont(new java.awt.Font("Arial Black", 0, 12));
        jLabel14.setText("SETTINGS AND CONTROL");

        jLabel2.setFont(new java.awt.Font("Tahoma", 1, 11));
        jLabel2.setText("Connection Status:");

        jButton1.setText("Connect Robot and GPS");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        jLabel15.setText("Not Connected");

        org.jdesktop.layout.GroupLayout jPanel1Layout = new org.jdesktop.layout.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jPanel1Layout.createSequentialGroup()
                        .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jPanel1Layout.createSequentialGroup()
                                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                                    .add(jPanel1Layout.createSequentialGroup()
                                        .add(jLabel1)
                                        .add(12, 12, 12)
                                        .add(jComboBox1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 105, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                                    .add(jPanel1Layout.createSequentialGroup()
                                        .add(jLabel6)
                                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                        .add(jComboBox2, 0, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                                .add(15, 15, 15)
                                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                                    .add(jPanel1Layout.createSequentialGroup()
                                        .add(jLabel8)
                                        .add(12, 12, 12)
                                        .add(jTextField5))
                                    .add(jPanel1Layout.createSequentialGroup()
                                        .add(jLabel9)
                                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                        .add(jTextField6, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 92, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))))
                            .add(jPanel1Layout.createSequentialGroup()
                                .add(jLabel2)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jLabel15))
                            .add(jButton1))
                        .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jPanel1Layout.createSequentialGroup()
                                .add(93, 93, 93)
                                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                    .add(jButton5)
                                    .add(jButton4)))
                            .add(jPanel1Layout.createSequentialGroup()
                                .add(21, 21, 21)
                                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                                    .add(jButton8)
                                    .add(jButton6))
                                .add(57, 57, 57)
                                .add(jButton7))))
                    .add(jPanel1Layout.createSequentialGroup()
                        .add(jLabel14)
                        .add(232, 232, 232)
                        .add(jLabel13)))
                .add(1382, 1382, 1382))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel14)
                    .add(jLabel13))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel1)
                    .add(jComboBox1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jLabel8)
                    .add(jTextField5, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jButton4))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                        .add(jLabel6)
                        .add(jComboBox2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                        .add(jLabel9)
                        .add(jTextField6, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(jButton7)
                        .add(jButton6)))
                .add(4, 4, 4)
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(jPanel1Layout.createSequentialGroup()
                        .add(jButton5)
                        .add(8, 8, 8))
                    .add(jPanel1Layout.createSequentialGroup()
                        .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(jLabel2)
                            .add(jLabel15))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)))
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jButton8)
                    .add(jButton1))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jPanel3.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jLabel7.setFont(new java.awt.Font("Arial Black", 0, 12));
        jLabel7.setText("AUTONOMUS INFORMATION");

        jLabel3.setText("Current Latitude");

        jLabel4.setText("Current Longitude");

        jTextField2.setText("4335.2520");

        jTextField3.setText("8446.0878");

        jLabel5.setText("Distance to Target");

        jLabel10.setText("Heading Bot Needs");

        jLabel11.setText("True Heading Azemuth");

        jLabel12.setText("Direction Pointer");

        jButton2.setText("START AUTONOMUS MODE");
        jButton2.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                GPS_Drive(evt);
            }
        });

        org.jdesktop.layout.GroupLayout jPanel3Layout = new org.jdesktop.layout.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jLabel7)
                    .add(jPanel3Layout.createSequentialGroup()
                        .add(jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel3Layout.createSequentialGroup()
                                .add(jLabel3)
                                .add(30, 30, 30))
                            .add(jPanel3Layout.createSequentialGroup()
                                .add(jTextField2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 81, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .add(28, 28, 28)))
                        .add(jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, jLabel4)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, jTextField3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 91, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                    .add(jPanel3Layout.createSequentialGroup()
                        .add(jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jLabel5)
                            .add(jLabel10))
                        .add(8, 8, 8)
                        .add(jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                            .add(jTextField7)
                            .add(jTextField4, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 215, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))))
                .add(18, 18, 18)
                .add(jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jLabel12, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 90, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                        .add(org.jdesktop.layout.GroupLayout.LEADING, jTextField9)
                        .add(org.jdesktop.layout.GroupLayout.LEADING, jTextField8)
                        .add(org.jdesktop.layout.GroupLayout.LEADING, jLabel11, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                    .add(jButton2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 250, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(58, Short.MAX_VALUE))
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel3Layout.createSequentialGroup()
                .add(jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jPanel3Layout.createSequentialGroup()
                        .add(jLabel7)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(jLabel3)
                            .add(jLabel4))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(jTextField2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(jTextField3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                    .add(jPanel3Layout.createSequentialGroup()
                        .add(jLabel11)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jTextField8, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jLabel12)))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jPanel3Layout.createSequentialGroup()
                        .add(jTextField9, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(16, 16, 16)
                        .add(jButton2))
                    .add(jPanel3Layout.createSequentialGroup()
                        .add(jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(jLabel5)
                            .add(jTextField4, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                        .add(9, 9, 9)
                        .add(jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(jLabel10)
                            .add(jTextField7, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))))
                .add(49, 49, 49))
        );

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jPanel3, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jPanel1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 654, Short.MAX_VALUE))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(jPanel1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel3, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
// ## DATE: 4/1/2007
// ## AUTHOR: Charles Palen (palen1c@gmail.com)
// ## DESCRIPTION: This function executes the operations that get a gps sentence from the serial port.
// ## It examines the gps sentence to see if it is valid or not, then returns a valid GPS or gets attemps to
// ## get a valid gps sentence again.
// ## PRECONDITIONS: Should have different serial port selected for the GPS and Robot.
// ## POSTCONDITIONS: The serial connection will either be connected or disconnected depending on its prior status
      // Do we connect or disconnect (just checking one of the connections)?
         if(GPS_SerialConnected == false){
         // CONNECT   
            // Make sure that the serial ports are not the same for the robot and gps
               if(jComboBox1.getSelectedItem() == jComboBox2.getSelectedItem()){
                  // Warn user to change serial ports and break operation
                     JOptionPane.showMessageDialog(null,"Please make sure that different serial ports are selected"); 
               }
            // Make the connections
               GPS_SerialConnected = GPS_SERIAL.Connect((String)jComboBox1.getSelectedItem(),4800);
             //  Robot_SerialConnected = ROBOT_SERIAL.Connect((String)jComboBox1.getSelectedItem(),115200);
            // Enable the GUI controls
               jButton4.setEnabled(true);
               jButton5.setEnabled(true);
               jButton6.setEnabled(true);
               jButton7.setEnabled(true);
               jButton8.setEnabled(true);
               jButton2.setEnabled(true);
            // Change the button state
               jButton1.setText("Disconnect Robot and GPS");
         } else {
         // DISCONNECT   
            // Disconnect
               GPS_SERIAL.Disconnect();
             //  ROBOT_SERIAL.Disconnect();
            // Change the global variables 
               GPS_SerialConnected = false;
               Robot_SerialConnected = false;
            // Disable the GUI controls
               jButton4.setEnabled(false);
               jButton5.setEnabled(false);
               jButton6.setEnabled(false);
               jButton7.setEnabled(false);
               jButton8.setEnabled(false);
               jButton2.setEnabled(false);
            // Change the button state
               jButton1.setText("Connect Robot and GPS");
         }
         
    }//GEN-LAST:event_jButton1ActionPerformed

    private void GPS_Drive(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_GPS_Drive
        if (this.jButton2.getText() != "STOP AUTONOMUS MODE") {
            this.jButton2.setText("STOP AUTONOMUS MODE");
            // Making it so the destination coordinates can't be changed
            this.jTextField5.setEditable(false);
            this.jTextField6.setEditable(false);
            this.jComboBox1.setEditable(false);
            // Starting the timer that runs the processes for autodrive
            RobotDriveTimer.start();
        } else {
            // Stoping the timer that runs the processes for autodrive
            RobotDriveTimer.stop();
            // Making it so the destination coordinates can be changed again
            this.jTextField5.setEditable(true);
            this.jTextField6.setEditable(true);
            this.jComboBox1.setEditable(true);
            this.jButton2.setText("START AUTONOMUS MODE");
        }
    }//GEN-LAST:event_GPS_Drive
    
    // This is the code that is run every few seconds while the auto-drive is on
    ActionListener DriveByWire = new ActionListener() {
        public synchronized void actionPerformed(ActionEvent actionEvent) {
            // Setting a global variable so that this won't run if the time limit is up and it is still running
            // from the last timer event.
            if (Autonomus_Currently_Running == false){
                System.out.println("STARTING A LOOP");
                Autonomus_Currently_Running = true;
                
                // Grabbing the destination cordinates from the text boxes
                double Destination_Latitude = Double.parseDouble(jTextField5.getText().trim());
                double Destination_Longitude = Double.parseDouble(jTextField6.getText().trim());
                

                double[] TmpCoordinates = Robo_Handle_GPS();
                Robot_Handle_Lat_Long_Azemuth(TmpCoordinates,Destination_Latitude,Destination_Longitude);
            }// For the first if statement
            
            // Turning the global variable to false so that the timed event can run again
            Autonomus_Currently_Running = false;
            System.out.println("DONE WITH A LOOP");
        }
        
    };
    
    // The Constructor for the timer that handles the autonomus drive- Set to 1.5 second intervals
    Timer RobotDriveTimer = new Timer(1500,DriveByWire);
    
// ## NAME: Robo_Handle_GPS
// ## DATE: 12/05/2006
// ## AUTHOR: Charles Palen
// ## DESCRIPTION: This function is called by the autonomus loop in order to process the actions that handle
// ## interaction with the gps unit.
// ## PRECONDITIONS: NONE
// ## POSTCONDITIONS: GPS String is put into a global variable for further processing
      public synchronized double[] Robo_Handle_GPS() {
          while(XYZ_Running == true){
              try {
                        wait();
                    } catch (InterruptedException e){}
          }
      // Setting the value for GPS running to true so both gps and drive control cant run at the same time.  
         GPS_Running = true;
         
      // Opening a connection to the serial port with the speed for the GPS
      //   boolean S_Connected = SERIAL.Connect((String)jComboBox1.getSelectedItem(),4800);
                
      // If connected, trying to get a string of data from the input that begins with the specified character
      // In this case, GPS data.
         if (GPS_SerialConnected == true){
             TempString = GPS_SERIAL.Get_Byte_Stream_As_String(74,'$');
            //SERIAL.Disconnect();
          }
                   
         
      // Passing the grabbed string to the GPS class for parsing into lat, long, and azemuth.
         double[] Coordinates = MYGPS.Parse_GPS(TempString);
         GPS_Running = false;
         notifyAll();
         return Coordinates;
      }
      
// ## NAME: Robo_Handle_Lat_Long_Azemuth
// ## DATE: 12/05/2006
// ## AUTHOR: Charles Palen
// ## DESCRIPTION: This function is called by the autonomus loop in order to process the GPS, heading and azemuth
// ## when there is only a latitude and longitude
// ## PRECONDITIONS: Parsed coordinates must be sent to this function
// ## POSTCONDITIONS: NONE
      private synchronized void Robot_Handle_Lat_Long_Azemuth (double[] Coordinates,double Destination_Latitude,double Destination_Longitude){
      while(GPS_Running == true){
          try {
               wait();
              } catch (InterruptedException e){}
      }
   // Setting the running boolean to true so the gps cant be running at the same time.
      XYZ_Running = true;
      
   // Checking for a 5 in spot zero.  This indicates no gps data    
      if (Coordinates[0] != 5) {
          int[] Motor_Speed;
          
  // Displaying out current coordinates in the GUI        
      jTextField2.setText(Double.toString(Coordinates[0]));
      jTextField3.setText(Double.toString(Coordinates[1]));
  // Displaying the current true heading if one was able to be triangulated by the GPS (it would need three satalites in range to do this)    
       if (Coordinates[2] != 555555){
           jTextField8.setText(Double.toString(Coordinates[2]));
       } 
      
       // Calculating the distance and heading between the two GPS coordinates
          double[] Distance_Heading = GPS_Assist.GPS_Distance_Heading(Coordinates[0],Coordinates[1],Destination_Latitude,Destination_Longitude);
                        
        // Updating the distance and heading in the GUI
           jTextField4.setText(Double.toString(Distance_Heading[0]));
           jTextField7.setText(Double.toString(Distance_Heading[1]));
                        
         // Calculating the wheel speeds based on the distance and heading
           if (Coordinates[2] != 555555){
             Motor_Speed = Hemmison_Drive.DetermineBestSpeed(Distance_Heading[0], (Distance_Heading[1] - Coordinates[2]));
           } else {
             Motor_Speed = Hemmison_Drive.DetermineBestSpeed(Distance_Heading[0],0);       
           }
           
        // Getting the wheel speed string for output to the serial port
System.out.println("Setting motor speed in auto" + Motor_Speed[0] + Motor_Speed[1]);
           TempString = Hemmison_Drive.Motor_Control(Motor_Speed[0],Motor_Speed[1]);
           
      } else {
        // We never got coordinates from GPS.  Setting robo to halt until we get some. 
           TempString = Hemmison_Drive.Motor_Control(0,0);
      }
        // Trying to connect to the serial port
        // Opening a connection to the serial port with the speed for the Hemmisson
        //     boolean S_Connected = SERIAL.Connect((String)jComboBox2.getSelectedItem(),115200);   
       // If connected, sending the string to serial port output
          if (Robot_SerialConnected == true){
             try{
                ROBOT_SERIAL.Send_Data(TempString);
                 } catch(IOException e) {System.out.println("Couldn't set the motor speed");}
               // Trying to close the serial port
                  //SERIAL.Disconnect();
              }
                
         XYZ_Running = false;
         notifyAll();
      }
          
    private void jButton8MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButton8MouseClicked
        // Creating a new instance of the Hemmi_Control Class to call non-static functions
           Hemmi_Control Hemmi = new Hemmi_Control();
        // Calling the function in Hemmi_Control to make the bot STOP
           String TempString = Hemmi.Motor_Control(0,0);
                
                    // If connected, sending the string to serial port output
                       if (Robot_SerialConnected == true){
                          try{
                              ROBOT_SERIAL.Send_Data(TempString);
                          } catch(IOException e) {System.out.println("Couldn't set the motor speed");}
                       }
                
    }//GEN-LAST:event_jButton8MouseClicked
    
    private void jButton5MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButton5MouseClicked
        // Creating a new instance of the Hemmi_Control Class to call non-static functions
           Hemmi_Control Hemmi = new Hemmi_Control();
        // Calling the function in Hemmi_Control to make the bot STOP
           String TempString = Hemmi.Motor_Control(-5,-5);
                
                    // If connected, sending the string to serial port output
                       if (Robot_SerialConnected == true){
                          try{
                              ROBOT_SERIAL.Send_Data(TempString);
                          } catch(IOException e) {System.out.println("Couldn't set the motor speed");}
                       }
           
    }//GEN-LAST:event_jButton5MouseClicked
    
    private void jButton7MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButton7MouseClicked
        // Creating a new instance of the Hemmi_Control Class to call non-static functions
           Hemmi_Control Hemmi = new Hemmi_Control();
        // Calling the function in Hemmi_Control to make the bot STOP
           String TempString = Hemmi.Motor_Control(3,-3);
                
                    // If connected, sending the string to serial port output
                       if (Robot_SerialConnected == true){
                          try{
                              ROBOT_SERIAL.Send_Data(TempString);
                          } catch(IOException e) {System.out.println("Couldn't set the motor speed");}
                       }
                
    }//GEN-LAST:event_jButton7MouseClicked
    
    private void jButton6MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButton6MouseClicked
        // Creating a new instance of the Hemmi_Control Class to call non-static functions
           Hemmi_Control Hemmi = new Hemmi_Control();
        // Calling the function in Hemmi_Control to make the bot STOP
           String TempString = Hemmi.Motor_Control(-3,3);
                
                    // If connected, sending the string to serial port output
                       if (Robot_SerialConnected == true){
                          try{
                              ROBOT_SERIAL.Send_Data(TempString);
                          } catch(IOException e) {System.out.println("Couldn't set the motor speed");}
                       }

    }//GEN-LAST:event_jButton6MouseClicked
    
    private void jButton4MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButton4MouseClicked
        // Creating a new instance of the Hemmi_Control Class to call non-static functions
           Hemmi_Control Hemmi = new Hemmi_Control();
        // Calling the function in Hemmi_Control to make the bot STOP
           String TempString = Hemmi.Motor_Control(5,5);
                
                    // If connected, sending the string to serial port output
                       if (Robot_SerialConnected == true){
                          try{
                              ROBOT_SERIAL.Send_Data(TempString);
                          } catch(IOException e) {System.out.println("Couldn't set the motor speed");}
                       }
                
    }//GEN-LAST:event_jButton4MouseClicked
        
        
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new GPS_GetUI().setVisible(true);
            }
            
        });
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton4;
    private javax.swing.JButton jButton5;
    private javax.swing.JButton jButton6;
    private javax.swing.JButton jButton7;
    private javax.swing.JButton jButton8;
    private javax.swing.JComboBox jComboBox1;
    private javax.swing.JComboBox jComboBox2;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel14;
    private javax.swing.JLabel jLabel15;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JTextField jTextField2;
    private javax.swing.JTextField jTextField3;
    private javax.swing.JTextField jTextField4;
    private javax.swing.JTextField jTextField5;
    private javax.swing.JTextField jTextField6;
    private javax.swing.JTextField jTextField7;
    private javax.swing.JTextField jTextField8;
    private javax.swing.JTextField jTextField9;
    // End of variables declaration//GEN-END:variables
    
    
}
