/*
 * Licensed under the MIT License.
 *
 * Copyright (c) 2007 Charles D Palen
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */
/*
 * Hemmi_Control.java
 *
 * Created on November 21, 2006, 8:07 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package my.GPS_Get;

// Used for the Hash Table of Angles
   import java.util.Hashtable;
   import java.util.Enumeration;
   
public class Hemmi_Control {

 // Class Datamembers 
    int MotorGain = 0;
    
    
    /** Creates a new instance of Hemmi_Control */
    public Hemmi_Control() {
    }
    
// ## NAME: Motor_Control
// ## DATE: 11/21/2006
// ## AUTHOR: Charles Palen (palen1c@gmail.com)
// ## DESCRIPTION: This function takes in a speed from -9 to 9 for the left and right hemmison motor control as integers.
// ## It then attempts to use serial communication to set the left and right motor control at the input speed
// ## PRECONDITIONS: None, but the serial port should be hooked to a Hemmison robot.
// ## POSTCONDITIONS: The speeds of both motors will be set at the input speed, or an error will be returned.
    public String Motor_Control (int left_speed,int right_speed){

        // Initializing a return string
           String Motor_Speed;
           
        if ( (left_speed >= -9 && left_speed <= 9) || (right_speed >= -9 && right_speed <= 9) ) {

          // Building the ouptut string
             Motor_Speed = "D," + Integer.toString(left_speed) + "," + Integer.toString(right_speed) + '\r';

        } else {

          // Building the ouptut string
             Motor_Speed = "D,0,0" + '\r'; 
               
          // Setting the bot to full stop on error, until we call it again and get an accurate reading
            System.out.println("Bot Set to Full Halt On Invalid Speed Input");
        }
           
      return Motor_Speed;
     }

// ################ NOT USED ANYMORE - REPLACED BY DetermineBestSpeed ###################
// ## NAME: GPS_To_Motor_Calculation
// ## DATE: 11/27/2006
// ## AUTHOR: Charles Palen (palen1c@gmail.com)
// ## DESCRIPTION: This function takes in the distance and an angle to turn calculates the speed
// ## that both wheels need to be set at in order to reach the next waypoint.
// ## PRECONDITIONS: Must obtain the correct readings from the GPS
// ## POSTCONDITIONS: The speeds of both motors will be returned in an integer array Left in spot 0, right in 1
// ################ NOT USED ANYMORE - REPLACED BY DetermineBestSpeed ###################
    public int[] GPS_T0_Motor_Calculation (double GPS_Distance_To_Waypoint, double Angle_To_Turn){
    // Setting some distance parameters
       double SlowDownBoundry = .001; //Engines will cut to half speed when five feet from target
       double StopBoundry = .0001;  //Engines will be set to 0 if .0001 miles away from target
       
    // Setting some turn angle parameters
       double LOW_SlowerTurnBoundry = 90;
       double HI_SlowerTurnBoundry = 270;

    // Initializing the return array 
       int[] return_LRSpeed = new int[2];
    
        if (Angle_To_Turn < 0) {  
           Angle_To_Turn = Angle_To_Turn + 360;
          // ## We need to go on a RIGHT ANGLE ##
          // Perform calculations that make the left wheel turn faster then the right
             if ( (Angle_To_Turn < 90) || (Angle_To_Turn > 270) ) {
                  if(GPS_Distance_To_Waypoint <= SlowDownBoundry) {
                     if (GPS_Distance_To_Waypoint <= StopBoundry) {
                          return_LRSpeed[0] = 0;
                          return_LRSpeed[1] = 0;
                      } else {
                          return_LRSpeed[0] = 5;
                          return_LRSpeed[1] = 3;
                       }
                  } else {
                    return_LRSpeed[0] = 9;
                    return_LRSpeed[1] = 7;
                  }
             } else {
               // We need to turn more sharply
                                               if(GPS_Distance_To_Waypoint <= SlowDownBoundry) {
                                                    if (GPS_Distance_To_Waypoint <= StopBoundry) {
                                                       return_LRSpeed[0] = 0;
                                                       return_LRSpeed[1] = 0;
                                                    } else {
                                                        return_LRSpeed[0] = 5;
                                                        return_LRSpeed[1] = 2;
                                                    }
                                                } else {
                                                        
                                                           return_LRSpeed[0] = 9;
                                                           return_LRSpeed[1] = 5;
                                                }
             }
        } else if (Angle_To_Turn == 0) {
          // ## We need to go STRAIGHT ##
          // Set both speeds the same
           
             // Checking for distance from target
                 if (GPS_Distance_To_Waypoint <= SlowDownBoundry) {
                       if (GPS_Distance_To_Waypoint <= StopBoundry) {
                        return_LRSpeed[0] = 0;
                        return_LRSpeed[1] = 0;
                       } else {
                        return_LRSpeed[0] = 4;
                        return_LRSpeed[1] = 4;
                       }
                 } else {
                    return_LRSpeed[0] = 9;
                    return_LRSpeed[1] = 9;
                 }
        } else {
          // ## We need to go on a LEFT ANGLE ##
          // Perform calculations that make the right wheel turn faster then the left
                  if ( (Angle_To_Turn < 90) || (Angle_To_Turn > 270) ) {
                   if(GPS_Distance_To_Waypoint <= SlowDownBoundry) {
                     if (GPS_Distance_To_Waypoint <= StopBoundry) {
                          return_LRSpeed[0] = 0;
                          return_LRSpeed[1] = 0;
                      } else {
                          return_LRSpeed[0] = 3;
                          return_LRSpeed[1] = 5;
                       }
                  } else {
                    return_LRSpeed[0] = 7;
                    return_LRSpeed[1] = 9;
                  }
             } else {
                      // We need to turn more sharply
                                               if(GPS_Distance_To_Waypoint <= SlowDownBoundry) {
                                                    if (GPS_Distance_To_Waypoint <= StopBoundry) {
                                                       return_LRSpeed[0] = 0;
                                                       return_LRSpeed[1] = 0;
                                                    } else {
                                                        return_LRSpeed[0] = 2;
                                                        return_LRSpeed[1] = 5;
                                                    }
                                                } else {
                                                        
                                                           return_LRSpeed[0] = 5;
                                                           return_LRSpeed[1] = 9;
                                                }
             } 
        }
       
      return return_LRSpeed;
     }

// ## NAME: DetermineBestSpeed
// ## DATE: 03/07/2007
// ## AUTHOR: Charles Palen (palen1c@gmail.com)
// ## DESCRIPTION: This function is passed two integers, one double.  The 
// ## 1. Angle to turn (not the true angle until checked for left/right)
// ## 2. Distance to target IN MILES
// ## It then uses the associative array with angle measurements to determine the
// ## best wheel speeds.  They are returned in a 2 space integer array slot 0 for left speed
// ## slot 1 for right speed.
// ## PRECONDITIONS: An angle to turn, left or right, and distance to target are passed to this function
// ## POSTCONDITIONS: The best guess wheel speeds are returned in an integer array
    public int[] DetermineBestSpeed(double _DistanceToTarget,double _AngleToTurn){
        int[] Return_WheelSpeeds = new int[2];
                
        // The angle coming in hasnt been cheked for left or right turn yet
        // Checking it and returning the proper turn angle
           int[] TrueAngleToTurn = new int[2];
           TrueAngleToTurn = TurnLeftOrRight(_AngleToTurn);
           int _LeftOrRight = TrueAngleToTurn[0];
System.out.println("Angle to turn:" + TrueAngleToTurn[1] + " And Distance to target is:"  + _DistanceToTarget);  
        // Calling the function that determines the suggested power level based on the distance we have left
        // to the target
           int SugPowerLevel = PowerFromDistance(_DistanceToTarget,TrueAngleToTurn[1]);

        // Appending the suggested power level to the angle to turn
System.out.println("Suggested Power Level is " + SugPowerLevel);           
        // THIS IS THE ASSOCIATIVE ARRAY OF ANGLE MEASUREMENTS
        // THE ANGLES ARE REPRESENTED AS FOLLOWS 
        // POWER LEVEL NUMBER NUMBER NUMBER
        // So 3025 would be speed level 3 angle 25 degrees
        // (Angles were measured using a ruler and a protractor by doing several actual tests)
           
        // The numbers on the RIGHT are the associated wheel speeds
           Hashtable MasterHemmiAngles = new Hashtable();
           MasterHemmiAngles.put("0000","00");
           // 01 skipped because it didnt have enough power to even move the robot
           MasterHemmiAngles.put("0030","02");
           MasterHemmiAngles.put("0050", "03");
           MasterHemmiAngles.put("0080", "04");
           MasterHemmiAngles.put("0090", "05");
           MasterHemmiAngles.put("0160", "06");
           MasterHemmiAngles.put("0175", "07");
           MasterHemmiAngles.put("0180", "08");
           MasterHemmiAngles.put("1000", "11");
           MasterHemmiAngles.put("1010", "12");
           MasterHemmiAngles.put("1030", "13");
           MasterHemmiAngles.put("1070", "14");
           MasterHemmiAngles.put("1090", "15");
           MasterHemmiAngles.put("1100", "16");
           MasterHemmiAngles.put("1130", "17");
           MasterHemmiAngles.put("1140", "18");
           MasterHemmiAngles.put("1180", "19");
           MasterHemmiAngles.put("2000", "22");
           MasterHemmiAngles.put("2020", "23");
           MasterHemmiAngles.put("2040", "24");
           MasterHemmiAngles.put("2050", "25");
           MasterHemmiAngles.put("2080", "26");
           MasterHemmiAngles.put("2095", "27");
           MasterHemmiAngles.put("2110", "28");
           MasterHemmiAngles.put("2150", "29");
           MasterHemmiAngles.put("3000", "33");
           MasterHemmiAngles.put("3020", "34");
           MasterHemmiAngles.put("3040", "35");
           MasterHemmiAngles.put("3060", "36");
           MasterHemmiAngles.put("3080", "37");
           MasterHemmiAngles.put("3110", "38");
           MasterHemmiAngles.put("3130", "39");
           MasterHemmiAngles.put("4000", "44");
           MasterHemmiAngles.put("4010", "45");
           MasterHemmiAngles.put("4040", "46");
           MasterHemmiAngles.put("4060", "47");
           MasterHemmiAngles.put("4090", "48");
           MasterHemmiAngles.put("4095", "49");
           MasterHemmiAngles.put("5000", "55");
           MasterHemmiAngles.put("5030", "56");
           MasterHemmiAngles.put("5050", "57");
           MasterHemmiAngles.put("5060", "58");
           MasterHemmiAngles.put("5080", "59");
           MasterHemmiAngles.put("6000", "66");
           MasterHemmiAngles.put("6020", "67");
           MasterHemmiAngles.put("6030", "68");
           MasterHemmiAngles.put("6060", "69");
           MasterHemmiAngles.put("7000", "77");
           MasterHemmiAngles.put("7010", "78");
           MasterHemmiAngles.put("7040", "79");
           MasterHemmiAngles.put("8000", "88");
           MasterHemmiAngles.put("8020", "89");
           MasterHemmiAngles.put("9000", "99");
           
            // This will keep track of our current closest value
               int ClosestValue = 360; //Max value so we start with highest possible
               String FinalValue = null;
            // Looping through each of the keys to see which is closest
                              String key;
                              String value;
                              String TempString;
                              int TempAngle = 0;
                              int TempPowerLevel = 0;
                              int TempAngleResult = 0;
                   for (Enumeration e=MasterHemmiAngles.keys(); e.hasMoreElements();) {
                            key = (String)e.nextElement();
                            // Now breaking up the key in order to manipulate it
                            TempString = key.substring(1,key.length());
                                // Convert Angle string to int
                                   TempAngle = Integer.parseInt(TempString);
                                // Get power level
                                   TempString = key.substring(0,1);
                                // Convert power level string to int
                                   TempPowerLevel = Integer.parseInt(TempString);
                            value = (String)MasterHemmiAngles.get(key);
                       // Now compare the possible values to the values passed to the function
                       // the objective is to find the closest match to power level and angle             
                            // Subtract the angle we need to turn from each possible angle to find
                            // the lest ammount of difference IF it is in the suggested power level
                               if(TempPowerLevel == SugPowerLevel) {
                                TempAngleResult = TrueAngleToTurn[1] - TempAngle;
                     // Allowing there to be a slight variance
                                 if((TempAngleResult <= ClosestValue) && (TempAngleResult >= -10)){
                                    // Keep track of the closest value and its corresponding key
                                   ClosestValue = TempAngleResult;
                                   FinalValue = value;
                                 }
                               }

                    }   // FOR THE FOR STATEMENT  
                              
           // Now Seeing if we need to turn left or right and making the appropriate adjustments
           // Also putting the appropriate power value into the int array for returning
           // REUSING TEMP VALUES FROM ABOVE
              TempString = null;
              String LeftSpeed = null;
              String RightSpeed = null;
              
              if( _LeftOrRight == 1){
               // Need to turn right so the wheel values need to be swapped
                  TempString = FinalValue;
                  LeftSpeed = TempString.substring(0,1);
                  RightSpeed = TempString.substring(1,2);
                  Return_WheelSpeeds[0] = Integer.parseInt(RightSpeed);
                  Return_WheelSpeeds[1] = Integer.parseInt(LeftSpeed);
              } else {
               // Turning left, so just put the values into the array
                  TempString = FinalValue;
                  LeftSpeed = TempString.substring(0,1);
                  RightSpeed = TempString.substring(1,2);
                  Return_WheelSpeeds[0] = Integer.parseInt(LeftSpeed);
                  Return_WheelSpeeds[1] = Integer.parseInt(RightSpeed);
              }
              
 System.out.println("Left Speed is " + Return_WheelSpeeds[0] + " and Right speed is " + Return_WheelSpeeds[1]);   
 
        return Return_WheelSpeeds;
    }
    
// ## NAME: PowerFromDistance
// ## DATE: 03/07/2007
// ## AUTHOR: Charles Palen (palen1c@gmail.com)
// ## DESCRIPTION: This function takes in the distance to target IN MILES and figures out the appropriate power
// ## level based on that distance.  The power level 0-9 is returned as an integer
// ## PRECONDITIONS: Distance to target must be passed to this function
// ## POSTCONDITIONS: The best guess power level is returned for the distance
    public int PowerFromDistance(double _DistanceToTarget, int _AngleToTurn){
        int Return_PowerLevel = 0;
        // Explanation of distances
        // .00007 miles is about 1/3 of a foot
        // .0001 miles is about 1/2 of a foot
        // .0002 miles is about 1 foot
        // .0003 miles is about 1.5 feet
        // .0005 miles is about 2.5 feet
        // .0007 miles is about 3.6 feet
        // .001 miles is about 5.3 feet
        // .0015 miles is about 8 feet
        // .002 miles is about 10 feet
        // .004 miles is about 21 feet
        
        // THIS IS THE ASSOCIATIVE ARRAY OF POSSIBLE DISTANCES AND POWER LEVELS
        // Distances on LEFT Power Levels on RIGHT
           Hashtable MasterPowerLevels = new Hashtable();
           MasterPowerLevels.put(new Double(.00007),new Integer(0));
           MasterPowerLevels.put(new Double(.0001),new Integer(1));
           MasterPowerLevels.put(new Double(.0002),new Integer(2));
           MasterPowerLevels.put(new Double(.0003),new Integer(3));
           MasterPowerLevels.put(new Double(.0005),new Integer(4));
           MasterPowerLevels.put(new Double(.0007),new Integer(5));
           MasterPowerLevels.put(new Double(.001),new Integer(6));
           MasterPowerLevels.put(new Double(.0015),new Integer(7));
           MasterPowerLevels.put(new Double(.002),new Integer(8));        
        // IF ANGLE TO TURN IS ABOVE 0 we CANT USE 9 BECAUSE IT ONLY GOES STRAIGHT
           MasterPowerLevels.put(new Double(.004),new Integer(9));
           
        // Figuring out which distance is closest to our distance from target
           double CurrentClosest = 9999; //This is the highest possible value
           double TempCalculation;
            // Looping through each of the keys to see which is closest

                              Double key;
                              Integer value;
                   for (Enumeration e=MasterPowerLevels.keys(); e.hasMoreElements();) {
                            key = (Double)e.nextElement();
                            value = (Integer)MasterPowerLevels.get(key);
                       // Look for the closest match
                          TempCalculation = _DistanceToTarget - key.doubleValue();
                          
                          if((TempCalculation <= CurrentClosest) && (TempCalculation >= 0)){
                            CurrentClosest = TempCalculation;
                            Return_PowerLevel = value.intValue();
                          }
                    }

        // Making sure that if the power level is 9, then the angle is 0.  If not making the
        // power level 8
           if (Return_PowerLevel == 9){
               if(_AngleToTurn != 0){
                   Return_PowerLevel = 8;
               }                
           }

        return Return_PowerLevel;
    }

// ## NAME: TurnLeftOrRight
// ## DATE: 03/14/2007
// ## AUTHOR: Charles Palen (palen1c@gmail.com)
// ## DESCRIPTION: This function is used to determine if we are going to be turning left or right.
// ## In order to make the most efficient turns in a 360 degree circle, it is
// ## important to only turn a maximum of 180 degrees in any one direction
// ## Here, we are examining our True Heading(current direciton in a 360 degree circle)
// ## in comparison to the way we need to be going.  We are also returning the appropriate true heading.
// ## PRECONDITIONS: An angle to turn, left or right, and distance to target are passed to this function
// ## POSTCONDITIONS: Returns in spot 0 either 0 for LEFT or 1 FOR RIGHT, and in spot 1 the proper angle to turn
      private int[] TurnLeftOrRight (double Angle_To_Turn) {
       int[] Return_LR = new int[2];
       
       if (Angle_To_Turn < 0) {  
           Angle_To_Turn = Angle_To_Turn + 360;
          // ## We need to turn RIGHT ##
           Return_LR[0] = 1;
        } else {
          // ## We need to turn LEFT ##
           Return_LR[0] = 0;
        }
          // ## Setting the turn angle
           Return_LR[1] = (int)Angle_To_Turn;
       return Return_LR;
      }
      
// ## NAME: LED_Control
// ## DATE: 11/29/2006
// ## AUTHOR: Charles Palen (palen1c@gmail.com)
// ## DESCRIPTION: This function takes in an integer, either 1(on) or 0(off) and the COMM Port then opens a serial port connection and sends the
// ## string to either turn the two front LED's on or off.    
// ## PRECONDITIONS: The serial port should be hooked to a Hemmison robot, either a 1 or 0 should be sent to this method
// ## POSTCONDITIONS: The LED's on the Hemmisson will be set to the input status.
    public String LED_Control (int ON_OFF){
        // Initializing a return string
           String LED_Status;
              
        // Seeing what string to send
           if (ON_OFF == 0) {               
             LED_Status = "L,0,0,0,0" + '\r';
           } else {
             LED_Status = "L,0,0,1,1" + '\r';
           }
          return LED_Status;
    }    
 
}
    



